---
- name: Ensure gitops directories exist
  include_tasks:
    file: create_gitops_dirs.yml
  vars:
    gitops_component: metallb

- name: Create IPAddressPools
  template:
    src: metallb/addresspool.yaml.j2
    dest: "{{ openshift_gitops_dir }}/metallb/assets/addresspool-{{ item.name }}.yaml"
  loop: "{{ metallb.addresspools }}"

- name: Create BGPPeers
  template:
    src: metallb/bgppeer.yaml.j2
    dest: "{{ openshift_gitops_dir }}/metallb/assets/bgppeer-{{ item.name }}.yaml"
  loop: "{{ metallb.peers }}"

- name: Create BGPAdverstisements
  template:
    src: metallb/bgpadvertisement.yaml.j2
    dest: "{{ openshift_gitops_dir }}/metallb/assets/bgpadvertisement-{{ item.name }}.yaml"
  loop: "{{ metallb.bgpadvertisements | default([]) }}"

- name: Create L2Adverstisements
  template:
    src: metallb/l2advertisement.yaml.j2
    dest: "{{ openshift_gitops_dir }}/metallb/assets/l2advertisement-{{ item.name }}.yaml"
  loop: "{{ metallb.l2advertisements | default([]) }}"

- name: Template extra LoadBalancer Service for default Ingress
  template:
    src: metallb/router-metallb-default.yaml.j2
    dest: "{{ openshift_gitops_dir }}/metallb/assets/router-metallb-default.yaml"
  when:
  - metallb.add_default_ingress_service | default(false)

- name: Generate kustomization file
  include_tasks:
    file: generate_kustomization.yml
  vars:
    gitops_component: metallb
